/**
 * PithHelmet
 * Copyright 2003, Mike Solomon <mas63@cornell.edu>
 * $Header: /Users/msolomon/Developer/cvs/PithHelmet/NSPreferences.h,v 1.3 2003/04/12 06:05:53 msolomon Exp $
 *
 * class-dump'd from the AppKit framework (Jaguar)
 * Comments from GPGMail
 */

#import <Cocoa/Cocoa.h>

@class NSBox;
@class NSImage;
@class NSView;
@class NSMutableArray;
@class NSMutableDictionary;
@class NSWindow;
@class NSMatrix;
@class NSButtonCell;


@protocol NSPreferencesModule
- (void)moduleWasInstalled;
- (void)moduleWillBeRemoved;
- (void) didChange;
- (void) initializeFromDefaults;
- (void) willBeDisplayed; // Called many times, unlike awakeFromNib
- (void) saveChanges; // It may happen that nib has NOT YET been loaded
- (BOOL) hasChangesPending;
- (NSImage *) imageForPreferenceNamed:(NSString *)aName; // Called only once
- (NSView *) viewForPreferenceNamed:(NSString *)aName;
@end

@interface NSPreferences : NSObject
{
    NSWindow			*preferencesPanel;
    NSBox				*preferenceBox;
    NSMatrix			*moduleMatrix;
    NSButtonCell		*okButton;
    NSButtonCell		*cancelButton;
    NSButtonCell		*applyButton;
    NSMutableArray		*_preferenceTitles;
    NSMutableArray		*_preferenceModules;
    NSMutableDictionary	*_masterPreferenceViews;
    NSMutableDictionary	*_currentSessionPreferenceViews;
    NSBox				*_originalContentView;
    BOOL				_isModal;
    float _constrainedWidth;
    id _currentModule;
}

+ (id) sharedPreferences;
+ (void) setDefaultPreferencesClass:(Class)aClass;
+ (Class) defaultPreferencesClass;
- (id) init;
- (void) dealloc;
- (void) addPreferenceNamed:(NSString *)aName owner:(id)owner;
- (void) _addItemWithName:(NSString *)aName owner:(id)owner;
- (void) _setupUI;
- (NSSize) preferencesContentSize;
- (void) showPreferencesPanel;
- (void) showPreferencesPanelForOwner:(id)owner;
- (int) showModalPreferencesPanelForOwner:(id)owner;
- (int) showModalPreferencesPanel;
- (void) ok:(id)sender;
- (void) cancel:(id)sender;
- (void) apply:(id)sender;
- (void) selectModule:(id)sender;
- windowTitle;
- (void)confirmCloseSheetIsDone:fp12 returnCode:(int)fp16 contextInfo:(void *)fp20;
- (BOOL) windowShouldClose:(id)sender;
- (void) windowDidResize:(id)sender;
- (NSRect)windowWillResize:fp16 toSize:(NSRect)fp20;
- (BOOL)usesNewLayout;
- (BOOL)usesButtons;

@end

@interface NSPreferencesModule : NSObject <NSPreferencesModule>
{
    IBOutlet NSBox	*preferencesView;
    BOOL			hasChanges;
}

+ (id) sharedInstance;
- (void)dealloc;
- (id) init;
- (NSString *) preferencesNibName;
- (NSView *) viewForPreferenceNamed:(NSString *)aName;
- (NSImage *) imageForPreferenceNamed:(NSString *)aName;
- (BOOL) hasChangesPending;
- (void) saveChanges;
- (void) willBeDisplayed; // Called many times, unlike awakeFromNib
- (void) initializeFromDefaults;
- (void) didChange;
- (void)moduleWillBeRemoved;
- (void)moduleWasInstalled;

@end

@interface NSPreferences_PithHelmet : NSPreferences
{
}

+ (void) load;
- (NSWindow*) window;

@end
