/**
 * PithHelmet
 * @author Mike Solomon
 * Copyright 2003 Mike Solomon. All rights reserved.
 * $Header: /Users/msolomon/Developer/cvs/PithHelmet/PCRegExp.h,v 1.6 2003/04/20 07:43:33 msolomon Exp $
 */

#import <Foundation/Foundation.h>
#import "pcre.h"

#define PCREGEXP_MAX_SUB_PATTERNS 16

@interface PCRegExp : NSObject
{
	NSString* pattern;
	pcre* regex;
	pcre_extra* regex_extra;

	int offsetArray[PCREGEXP_MAX_SUB_PATTERNS];
	BOOL valid;
}
+ (BOOL) validatePattern:(NSString*)_pattern errorIndex:(int*)_errorIndex errorMessage:(NSString**)_errorMessage;
- (id)initWithString:(NSString*)_pattern;
- (BOOL)setPattern:(NSString*)_pattern;
- (BOOL)matchInString:(NSString*)_string;
- (NSString*)pattern;
- (BOOL) isValid;

- (int) substituteFrom:(NSString*) _srcString intoString:(NSMutableString*) _dstString usingPattern:(NSString*) _replacementPattern andMatch:(int) nmatch;
- (NSString*) replaceString:(NSString*)_string byPattern:(NSString*)_pattern;



@end
