/**
 * PithHelmet
 * @author Mike Solomon
 * Copyright 2003 Mike Solomon. All rights reserved.
 * $Header: /Users/msolomon/Developer/cvs/PithHelmet/PithHelmetLoadProgressMonitor.m,v 1.8 2003/11/13 17:29:04 msolomon Exp $
 */

RCS_ID("$Id: PithHelmetLoadProgressMonitor.m,v 1.8 2003/11/13 17:29:04 msolomon Exp $")

#import "PithHelmet.h"
#import "PithHelmetLoadProgressMonitor.h"


@implementation PithHelmetLoadProgressMonitor


- webView:(WebView*)sender resource:(id)identifier willSendRequest:(NSURLRequest*)request redirectResponse:(NSURLResponse *)redirectResponse fromDataSource:(WebDataSource*)dataSource
{
	DLog1(DLOG_40, (@"webView:(%@) resource:(%@) willSendRequest:(%@) redirectResponse:(%@) fromDataSource:(%@)", sender ,identifier, request, redirectResponse, dataSource));
	DLog1(DLOG_40, (@"webView:(%@) fromDataSource:(%@)", [[[[sender mainFrame] dataSource] request] URL], [[dataSource request] URL]));

	// the transmogrifier needs to work on even the url's we want to load, so do this before we exclude
	// url's in the location bar
	NSString* transmogrifiedUrl = [[PithHelmet sharedInstance] transmogrify:[request URL]];
	if (transmogrifiedUrl != nil)
	{
		DLog1(DLOG_40, (@"transmogrified url: %@", transmogrifiedUrl));
		return [NSURLRequest requestWithURL:[NSURL URLWithString:transmogrifiedUrl]];
	}

	// if this is the top-level request (as navigated by the location bar) then don't block the load
	if ([[(BrowserWebView*)sender expectedOrCurrentURL] isEqualTo:[request URL]])
		return request;

	// secretly switch regular coffee with Folger's crytals
	if ([[PithHelmet sharedInstance] allowResourceLoad:[request URL] withReferrer:[[dataSource request] URL]] == NO)
	{
		request = [NSURLRequest requestWithURL:[[PithHelmet sharedInstance] blockedFileForUrl:[request URL]]];
		DLog1(DLOG_10, (@"substituting url %@", request));
	}
	
	return request;
}


@end
