/**
 * PithHelmet
 * @author Mike Solomon
 * Copyright 2003 Mike Solomon. All rights reserved.
 * $Header: /Users/msolomon/Developer/cvs/PithHelmet/PithHelmetLocationChangeHandler.m,v 1.20 2003/08/17 08:49:48 msolomon Exp $
 */

RCS_ID("$Id: PithHelmetLocationChangeHandler.m,v 1.20 2003/08/17 08:49:48 msolomon Exp $")

#import "PithHelmet.h"
#import "PithHelmetLocationChangeHandler.h"

@implementation PithHelmetLocationChangeHandler


- (void) webView: (WebView *) sender didFinishLoadForFrame: (WebFrame *) frame
{
	DLog1(DLOG_30, (@"webView:didFinishLoadForFrame (%@ | %@)", sender, frame));
	[super webView:sender didFinishLoadForFrame:frame];
	if (nil != [frame parentFrame])
		DLog1(DLOG_30, (@"*** subframe"));

	NSURL* url = [[[frame dataSource] request] URL];
	// only collapse content if this is the top level frame
	// fixme: maybe we should collapse inside iframes if we don't block them?
	// fixme: move all this absoluteString crap into just passing a URL
	if ([frame parentFrame] == nil && [[frame dataSource] _isDocumentHTML] == YES && [[PithHelmet sharedInstance] shouldCollapseContentForUrl:url] == YES)
	{
		// FIXME: wish there was some way to cache this (in compiled form)
		NSString* javascriptlet = [[PithHelmet sharedInstance] collapseContentScriptlet];
		DLog1(DLOG_30, (@"exec javascript"));
	 	[sender stringByEvaluatingJavaScriptFromString:javascriptlet];
		[WebImageRenderer stopAnimationsInView:sender];
	}
	[[PithHelmet sharedInstance] finishLoad:url];
}

- (void) webView: (WebView *) sender didStartProvisionalLoadForFrame: (WebFrame *) frame
{
	DLog1(DLOG_30, (@"webView:didStartProvisionalLoadForFrame (%@ | %@)", sender, frame));
	[super webView:sender didStartProvisionalLoadForFrame:frame];
	if ([frame parentFrame] == nil)
	{
		DLog1(DLOG_30, (@"*** topLevelRequest: view:%@ (%@) frame:%@",[sender expectedOrCurrentURL], [sender locationFieldURL],  [[[frame dataSource] request] URL]));
//		DLog1(DLOG_30, (@"*** topLevelRequest: initreq:%@",[sender initialRequest]));
	}
}

- (void) webView: (WebView *) sender didCommitLoadForFrame: (WebFrame *) frame 
{
	DLog1(DLOG_30, (@"webView:didCommitLoadForFrame (%@ | %@)", sender, frame));
	[super webView:sender didCommitLoadForFrame:frame];
}

- (void) webView: (WebView *) sender didChangeLocationWithinPageForFrame: (WebFrame *) frame 
{
	DLog1(DLOG_30, (@"webView:didChangeLocationWithinPageForFrame (%@ | %@)", sender, frame));
	[super webView:sender didChangeLocationWithinPageForFrame:frame];
}

- (void) webView: (WebView *) sender willPerformClientRedirectToURL: (NSURL *) URL delay: (NSTimeInterval )seconds fireDate: (NSDate *) date forFrame: (WebFrame *) frame 
{
	DLog1(DLOG_30, (@"webView:%@ willPerformClientRedirectToURL:%@ delay:%e fireDate:%@ forFrame:%@", sender, URL, seconds, date, frame));
	[super webView:sender willPerformClientRedirectToURL:URL delay: seconds fireDate: date forFrame:frame];
}
@end
