/**
 * PithHelmet
 * Copyright 2003, Mike Solomon <mas63@cornell.edu>
 * $Header: /Users/msolomon/Developer/cvs/PithHelmet/Safari.h,v 1.10 2003/11/12 07:38:42 msolomon Exp $
 */

#import <WebKit/WebKit.h>

// these are header entries generated from class-dump's of Safari
// they are only here to kill the loud warnings

@interface BrowserDocument : NSDocument

-(NSURL*)currentURL;
-(void)reload:(id)_sender;
-(BOOL)_isDocumentHTML;
-(NSString*)evaluateJavaScript:(NSString*)_javascript;
- (void)clearPageCache;

@end


@interface BrowserDocumentController : NSDocumentController

+ (BrowserDocumentController*) sharedDocumentController;
- (BrowserDocument*) frontmostBrowserDocument;

@end


// FIXME: what i don't understand is why the struct size needs to match if
// i'm only ever dealing with the messages, not the actual data
@interface WebBaseResourceHandleDelegate:NSObject
{
    WebDataSource *dataSource;	// 4 = 0x4
    NSURLConnection *connection;	// 8 = 0x8
    NSURLRequest *request;	// 12 = 0xc
    WebView *webView;	// 16 = 0x10
    NSURLResponse *response;	// 20 = 0x14
    id identifier;	// 24 = 0x18
    id resourceLoadDelegate;	// 28 = 0x1c
    id downloadDelegate;	// 32 = 0x20
    NSURLAuthenticationChallenge *currentConnectionChallenge;	// 36 = 0x24
    NSURLAuthenticationChallenge *currentWebChallenge;	// 40 = 0x28
    char cancelledFlag;	// 44 = 0x2c
    char reachedTerminalState;	// 45 = 0x2d
    char defersCallbacks;	// 46 = 0x2e
    void* implementations;	// 48 = 0x30
}

- (void)releaseResources;
- (void)dealloc;
- (char)loadWithRequest:fp12;
- (void)setDefersCallbacks:(char)fp12;
- (char)defersCallbacks;
- (void)setDataSource:fp12;
- dataSource;
- resourceLoadDelegate;
- downloadDelegate;
- connection:fp12 willSendRequest:fp16 redirectResponse:fp20;
- (void)connection:fp12 didReceiveAuthenticationChallenge:fp16;
- (void)connection:fp12 didCancelAuthenticationChallenge:fp16;
- (void)connection:fp12 didReceiveResponse:fp16;
- (void)connection:fp12 didReceiveData:fp16;
- (void)connectionDidFinishLoading:fp12;
- (void)connection:fp12 didFailWithError:fp16;
- (void)cancelWithError:fp12;
- (void)cancel;
- cancelledError;
- (void)setIdentifier:fp12;
- response;

@end


@interface WebBaseNetscapePluginStream:NSObject
{
	NSMutableData *deliveryData;	// 4 = 0x4
	NSURL *URL;	// 8 = 0x8
	void *instance;	// 12 = 0xc
	unsigned short transferMode;	// 16 = 0x10
	int offset;	// 20 = 0x14
	int stream[6];	// 24 = 0x18
	char *path;	// 48 = 0x30
	void *notifyData;	// 52 = 0x34
	id plugin;	// 56 = 0x38
	short reason;	// 60 = 0x3c
	void *NPP_NewStream;	// 64 = 0x40
	void *NPP_DestroyStream;	// 68 = 0x44
	void *NPP_StreamAsFile;	// 72 = 0x48
	void *NPP_WriteReady;	// 76 = 0x4c
	void *NPP_Write;	// 80 = 0x50
	void *NPP_URLNotify;	// 84 = 0x54
}

- (void)dealloc;
- (unsigned short)transferMode;
- (void)setPluginPointer:(struct _NPP *)fp8;
- (void)setNotifyData:(void *)fp8;
- (void)startStreamWithURL:fp8 expectedContentLength:(long long)fp12 lastModifiedDate:fp20 MIMEType:fp24;
- (void)startStreamWithResponse:fp8;
- (void)destroyStream;
- (void)destroyStreamWithReason:(short)fp8;
- (void)receivedError:(short)fp8;
- (void)finishedLoadingWithData:fp8;
- (void)deliverData;

@end

@interface WebNetscapePluginStream:WebBaseNetscapePluginStream
{
	NSURLRequest *_startingRequest;	// 88 = 0x58
	id _loader;	// 92 = 0x5c
}

- initWithRequest:fp12 pluginPointer:(void*)fp16 notifyData:(void *)fp20;
- (void)dealloc;
- (void)start;
- (void)stop;

@end

@interface WebSubresourceClient:WebBaseResourceHandleDelegate
{
    id loader;	// 52 = 0x34
}

+ startLoadingResource:fp12 withURL:fp16 referrer:fp20 forDataSource:fp24;
- initWithLoader:fp12 dataSource:fp16;
- (void)dealloc;
- (void)receivedError:fp12;
- connection:fp12 willSendRequest:fp16 redirectResponse:fp20;
- (void)connection:fp12 didReceiveResponse:fp16;
- (void)connection:fp12 didReceiveData:fp16;
- (void)connectionDidFinishLoading:fp12;
- (void)connection:fp12 didFailWithError:fp16;
- (void)cancel;

@end

@interface WebMainResourceClient:WebBaseResourceHandleDelegate
{
    int _contentLength;	// 52 = 0x34
    int _bytesReceived;	// 56 = 0x38
    id listener;	// 60 = 0x3c
    NSURLResponse *policyResponse;	// 64 = 0x40
    id proxy;	// 68 = 0x44
}

- initWithDataSource:fp12;
- (void)dealloc;
- (void)receivedError:fp12;
- (void)cancelContentPolicy;
- (void)cancelWithError:fp12;
- interruptForPolicyChangeError;
- (void)stopLoadingForPolicyChange;
- (void)continueAfterNavigationPolicy:fp12 formState:fp16;
- connection:fp12 willSendRequest:fp16 redirectResponse:fp20;
- (void)continueAfterContentPolicy:(int)fp12 response:fp16;
- (void)continueAfterContentPolicy:(int)fp12;
- (void)checkContentPolicyForResponse:fp12;
- (void)connection:fp12 didReceiveResponse:fp16;
- (void)connection:fp12 didReceiveData:fp16;
- (void)connectionDidFinishLoading:fp12;
- (void)connection:fp12 didFailWithError:fp16;
- (char)loadWithRequest:fp12;
- (void)setDefersCallbacks:(char)fp12;

@end


@interface LocationChangeHandler:NSObject
{
    id _webView;	// 4 = 0x4
    NSString *_pendingErrorMessage;	// 8 = 0x8
    NSString *_pendingErrorTitle;	// 12 = 0xc
    NSURL *_loadErrorURL;	// 16 = 0x10
    id _previousHistoryItem;	// 20 = 0x14
}

- initWithWebView:fp12;
- (void)dealloc;
- previousHistoryItem;
- (void)setPreviousHistoryItem:fp12;
- (void)close;
- _mainFrame;
- _loadMonitor;
- (void)webView:fp12 didStartProvisionalLoadForFrame:fp16;
- (void)webView:fp12 didReceiveServerRedirectForProvisionalLoadForFrame:fp16;
- (void)webView:fp12 didCommitLoadForFrame:fp16;
- (void)webView:fp12 didReceiveTitle:fp16 forFrame:fp20;
- (void)webView:fp12 didReceiveIcon:fp16 forFrame:fp20;
- (void)continueHTTPSConnectionSheetDidEnd:fp12 returnCode:(int)fp16 contextInfo:(void *)fp20;
- (void)webView:fp12 locationChangeDone:fp16 forDataSource:fp20;
- (void)webView:fp12 didFailProvisionalLoadWithError:fp16 forFrame:fp20;
- (void)webView:fp12 didFinishLoadForFrame:fp16;
- (void)webView:fp12 didFailLoadWithError:fp16 forFrame:fp20;
- (void)webView:fp12 didChangeLocationWithinPageForFrame:fp16;
- (void)webView:fp12 willPerformClientRedirectToURL:fp16 delay:(double)fp40 fireDate:fp28 forFrame:fp32;
- (void)webView:fp12 didCancelClientRedirectForFrame:fp16;
- (void)webView:fp12 willCloseFrame:fp16;

@end


@interface TextCell:NSTextFieldCell
{
    char _doesNotTruncate;	// 48 = 0x30
    NSColor *_highlightPattern;	// 52 = 0x34
    NSColor *_secondaryHighlightPattern;	// 56 = 0x38
}

+ updateCellForColumn:fp12 inView:fp16;
- (struct _NSRect)adjustFrameToVerticallyCenterText:(struct _NSRect)fp16;
- (void)editWithFrame:(struct _NSRect)fp12 inView:fp28 editor:fp32 delegate:fp32 event:fp36;
- (void)selectWithFrame:(struct _NSRect)fp12 inView:fp28 editor:fp32 delegate:fp32 start:(int)fp36 length:(int)fp40;
- (void)drawInteriorWithFrame:(struct _NSRect)fp12 inView:fp28;
- initWithCell:fp12;
- (void)dealloc;
- copyWithZone:(struct _NSZone *)fp12;
- (char)centerTruncatesText;
- (void)setCenterTruncatesText:(char)fp12;
- (char)_usingAlternateHighlightColorWithFrame:(struct _NSRect)fp12 inView:fp28;
- (void)setHighlightPattern:fp12;
- highlightPattern;
- (void)setSecondaryHighlightPattern:fp12;
- secondaryHighlightPattern;

@end

@interface ImageAndTextCell:TextCell
{
    NSImage *image;	// 60 = 0x3c
}

- (void)dealloc;
- copyWithZone:(struct _NSZone *)fp12;
- (void)setImage:fp12;
- image;
- (void)getImageFrame:(struct _NSRect *)fp12 andTextFrame:(struct _NSRect *)fp16 fromCellFrame:(struct _NSRect)fp20;
- (struct _NSRect)imageFrameFromCellFrame:(struct _NSRect)fp16;
- (struct _NSRect)textFrameFromCellFrame:(struct _NSRect)fp16;
- (void)editWithFrame:(struct _NSRect)fp12 inView:fp28 editor:fp32 delegate:fp32 event:fp36;
- (void)selectWithFrame:(struct _NSRect)fp12 inView:fp28 editor:fp32 delegate:fp32 start:(int)fp36 length:(int)fp40;
- (void)drawWithFrame:(struct _NSRect)fp12 inView:fp28;
- (struct _NSSize)cellSize;

@end


@interface LoadProgressMonitor:NSObject
{
	id _mainEntry;     // 4 = 0x4
	id _webView;   // 8 = 0x8
	char _statusUpdatePending;  // 12 = 0xc
	char _havePreviouslyCommitted;      // 13 = 0xd
	long long _totalPageAndResourceBytesToLoad; // 16 = 0x10
	long long _totalPageBytesToLoad;    // 24 = 0x18
	double _maxIncrement;       // 32 = 0x20
}

- initWithWebView:fp12;
- (void)dealloc;
- (void)_setMainEntry:fp12;
- (void)reset;
- mainEntry;
- (void)close;
- _busyStatus;
- _statusSummary;
- (void)_updateStatusNow;
- (void)_updateStatusSoon;
- _monitorProvisionalDataSourceForFrame:fp12;
- (void)_incrementProgressBarWithOldBytes:(int)fp12 newBytes:(int)fp16 oldTotal:(int)fp20 newTotal:(int)fp24 isMainResource:(char)fp28;
- (void)monitorFrame:fp12;
- _createProgressEntryWithRequest:fp12 dataSource:fp16;
- (void)committedFrame:fp12;
- (void)titleChangedForFrame:fp12;
- (void)finishedLoadingFrame:fp12;
- (void)setError:fp12 forDataSource:fp16;
- title;
- (void)open;
- statusString;
- (int)stage;
- (unsigned int)numberOfChildren;
- childAtIndex:(unsigned int)fp12;
- (void)cancel:fp12;
- (int)displayOrder;
- (void)sortChildren;
- webView:fp12 identifierForInitialRequest:fp16 fromDataSource:fp20;
- webView:fp12 resource:fp16 willSendRequest:fp20 fromDataSource:fp24;
- (void)webView:fp12 resource:fp16 didReceiveResponse:fp20 fromDataSource:fp24;
- (void)webView:fp12 resource:fp16 didReceiveContentLength:(unsigned int)fp20 fromDataSource:fp24;
- (void)webView:fp12 resource:fp16 didFinishLoadingFromDataSource:fp20;
- (void)webView:fp12 resource:fp16 didFailLoadingWithError:fp20 fromDataSource:fp24;
- (void)launchApplicationSheetEnded:fp12 returnCode:(int)fp16 contextInfo:(void *)fp20;
- (void)pluginErrorSheetEnded:fp12 returnCode:(int)fp16 contextInfo:(void *)fp20;
- (void)webView:fp12 plugInFailedWithError:fp16 dataSource:fp20;

@end


@interface BrowserWebView:WebView
{
	BrowserDocument *_document; // 84 = 0x54
	LoadProgressMonitor *_loadMonitor;  // 88 = 0x58
	NSURLRequest *_initialRequest;      // 92 = 0x5c
	char _shouldStartEmpty;     // 96 = 0x60
	WebHistoryItem *_searchResultsForSnapBack;  // 100 = 0x64
	WebHistoryItem *_pageForSnapBack;   // 104 = 0x68
	char _nextPageShouldBeSnapBackPoint;        // 108 = 0x6c
	id bookmarksViewController;   // 112 = 0x70
	NSView *bookmarksViewContents;      // 116 = 0x74
	NSString *_statusText;      // 120 = 0x78
	NSString *_progressStatus;  // 124 = 0x7c
	id _progressStatusOwner;    // 128 = 0x80
	char _ellipsizeProgressStatus;      // 132 = 0x84
	NSString *_generalStatus;   // 136 = 0x88
	id _generalStatusOwner;     // 140 = 0x8c
	char _ellipsizeGeneralStatus;       // 144 = 0x90
	NSString *_userDrivenStatus;        // 148 = 0x94
	id _userStatusOwner;        // 152 = 0x98
	char _ellipsizeUserStatus;  // 156 = 0x9c
	NSString *_provisionalOriginalURLString;    // 160 = 0xa0
	NSString *_originalURLString;       // 164 = 0xa4
	NSString *_requestedTabLabel;       // 168 = 0xa8
	NSString *_provisionalTabLabel;     // 172 = 0xac
	NSString *_committedTabLabel;       // 176 = 0xb0
	NSArray *_fallbackURLs;     // 180 = 0xb4
	LocationChangeHandler *_locationChangeDelegate;     // 184 = 0xb8
	id _sheetRequest;        // 188 = 0xbc
	id _formDelegate;        // 192 = 0xc0
	double _redirectDelay;      // 196 = 0xc4
	double _progressValue;      // 204 = 0xcc
	char _progressValueReflectsSuccessfulCompletion;    // 212 = 0xd4
	char _isLoadingIgnoringQueue;       // 213 = 0xd5
	char _isLoadingConsideringQueue;    // 214 = 0xd6
	char _isWindowFocusDisabled;        // 215 = 0xd7
	NSURLRequest *_requestWaitingInQueue;       // 216 = 0xd8
}

+ (void)dequeueRequest;
+ (void)decrementLoadingCount;
- windowController;
- browserWindow;
- initWithDocument:fp12 request:fp16 frameName:fp20;
- (void)dealloc;
- (void)cancelDelayedProgressUpdate;
- (char)hasPendingError;
- (void)displayPendingError;
- (void)_closeDataSources:fp12;
- (void)close;
- document;
- loadMonitor;
- (void)webView:fp12 setStatusText:fp16;
- webViewStatusText:fp12;
- mouseoverTextForElement:fp12 modifierFlags:(unsigned int)fp16;
- (void)webView:fp12 mouseDidMoveOverElement:fp16 modifierFlags:(unsigned int)fp20;
- webView:fp12 createWebViewWithRequest:fp16;
- (void)webViewClose:fp12;
- (void)webViewShow:fp12;
- (void)webViewFocus:fp12;
- webViewFirstResponder:fp12;
- (void)webView:fp12 makeFirstResponder:fp16;
- (char)webViewAreToolbarsVisible:fp12;
- (void)webView:fp12 setToolbarsVisible:(char)fp16;
- (char)webViewIsStatusBarVisible:fp12;
- (void)webView:fp12 setStatusBarVisible:(char)fp16;
- (char)webViewIsResizable:fp12;
- (void)webView:fp12 setResizable:(char)fp16;
- mainWebFrameView;
- (void)webView:fp12 setFrame:(struct _NSRect)fp16;
- (struct _NSRect)webViewFrame:fp16;
- (void)webView:fp12 setContentRect:(struct _NSRect)fp16;
- (struct _NSRect)webViewContentRect:fp16;
- (void)webView:fp12 runJavaScriptAlertPanelWithMessage:fp16;
- (char)webView:fp12 runJavaScriptConfirmPanelWithMessage:fp16;
- webView:fp12 runJavaScriptTextInputPanelWithPrompt:fp16 defaultText:fp20;
- (void)webView:fp12 runOpenPanelForFileButtonWithResultListener:fp16;
- (void)openPanelDidEnd:fp12 returnCode:(int)fp16 contextInfo:(void *)fp20;
- (void)webView:fp12 unableToImplementPolicyWithError:fp16 frame:fp20;
- (void)openFileExternallyWithRequest:fp12 inFrame:fp16;
- (void)openURLExternallyWithRequest:fp12 inFrame:fp16;
- (void)revealInFinderWithRequest:fp12 inFrame:fp16;
- (void)webView:fp12 decidePolicyForMIMEType:fp16 request:fp20 frame:fp24 decisionListener:fp28;
- (void)tellListenerToUseContentPolicyAndRelease:fp12;
- (void)confirmSendSheetDidEnd:fp12 returnCode:(int)fp16 contextInfo:(void *)fp20;
- (void)decidePolicyForAction:fp12 request:fp16 frame:fp20 newFrameName:fp24 decisionListener:fp28;
- (void)webView:fp12 decidePolicyForNavigationAction:fp16 request:fp20 frame:fp24 decisionListener:fp28;
- (void)webView:fp12 decidePolicyForNewWindowAction:fp16 request:fp20 newFrameName:fp24 decisionListener:fp28;
- originalURLString;
- (void)setOriginalURLString:fp12;
- provisionalOriginalURLString;
- (void)setProvisionalOriginalURLString:fp12;
- statusMessage;
- (char)ellipsizeStatusMessage;
- (void)updateStatusInBrowserWindow;
- (void)setStatus:fp12 withPriority:(int)fp16 ellipsize:(char)fp20 owner:fp24;
- (void)clearAllStatus;
- currentURL;
- expectedOrCurrentURL;
- expectedOrCurrentOriginalURLString;
- (char)isShowingBookmarks;
- (void)loadBookmarksNibIfNecessary;
- bookmarksViewContents;
- bookmarksViewController;
- (char)canGoToPreviousLocation;
- (void)goToPreviousLocation;
- locationFieldURL;
- titleForLocationFieldURL;
- currentTitle;
- pageName;
- displayName;
- fallbackURLs;
- (void)goToNextFallbackURL;
- (char)isLoading;
- (double)progressValue;
- (double)progressValueIgnoringSuccessfulCompletionDelay;
- (void)setProgressValue:(double)fp40;
- (void)setProgressValueToZero;
- (void)setProgressValueToReflectSuccessfulCompletion;
- (void)setPendingRedirectDelay:(double)fp40;
- (void)cancelPendingRedirect;
- (double)pendingRedirectDelay;
- (char)canMakeTextSmaller;
- (char)canMakeTextLarger;
- (void)snapBackTo:fp12;
- (char)nextPageShouldBeSnapBackPoint;
- (void)setNextPageShouldBeSnapBackPoint:(char)fp12;
- (void)setPageForSnapBack:fp12;
- (void)setPageForSnapBackToCurrentPage:fp12;
- (char)canSnapBackToPage;
- (void)snapBackToPage:fp12;
- pageForSnapBack;
- (void)setSearchResultsForSnapBack:fp12;
- (void)setSearchResultsForSnapBackToCurrentPage;
- (void)clearSearchResultsForSnapBack;
- (char)canSnapBackToSearchResults;
- (void)snapBackToSearchResults:fp12;
- searchResultsForSnapBack;
- (void)queueRequest:fp12;
- removeRequestFromQueue;
- (void)goNowIfInQueue;
- (void)stopLoading:fp12;
- (char)validateUserInterfaceItem:fp12;
- (void)setAcceptsGenericIcon:(char)fp12;
- (void)updateIcon;
- (void)nameHasChanged;
- (void)pageTitleHasChanged;
- (void)updateLocationFieldIfNecessary;
- (void)currentURLHasChanged;
- (void)provisionalURLHasChanged;
- (void)pageLoadingStatusHasChanged;
- (void)mainDataSourceHasChanged;
- (void)goToRequest:fp12 allowJavaScript:(char)fp16 waitInQueue:(char)fp20;
- (void)setFallbackURLs:fp12;
- (void)goToURL:fp12 withFallbackURLs:fp16;
- (void)goToURL:fp12;
- (void)tryMultipleURLs:fp12;
- stringByEvaluatingJavaScriptFromString:fp12;
- (char)hasInitialContents;
- (void)displayInitialContents;
- (void)setShouldStartEmpty;
- (void)clearPageCache;
- (char)isWindowFocusDisabled;
- (void)setWindowFocusDisabled:(char)fp12;

@end

@interface WebImageRenderer:NSImage
{
    NSTimer *frameTimer;	// 28 = 0x1c
    NSView *frameView;	// 32 = 0x20
    struct _NSRect imageRect;	// 36 = 0x24
    struct _NSRect targetRect;	// 52 = 0x34
    int loadStatus;	// 68 = 0x44
    NSColor *patternColor;	// 72 = 0x48
    int patternColorLoadStatus;	// 76 = 0x4c
    int repetitionsComplete;	// 80 = 0x50
    char animationFinished;	// 84 = 0x54
    char sawGIFExtensionSignature;	// 85 = 0x55
    char GIFExtensionBuffer[10];	// 86 = 0x56
    int GIFExtensionBufferLength;	// 96 = 0x60
    NSString *MIMEType;	// 100 = 0x64
    char isNull;	// 104 = 0x68
}

+ (void)stopAnimationsInView:fp12;
- (char)blockHasGIFExtensionSignature:(const char *)fp12 length:(int)fp16;
- (void)checkDataForGIFExtensionSignature:fp12;
- initWithMIMEType:fp12;
- initWithData:fp12 MIMEType:fp16;
- initWithContentsOfFile:fp12;
- copyWithZone:(struct _NSZone *)fp12;
- (char)isNull;
- (char)incrementalLoadWithBytes:(const void *)fp12 length:(unsigned int)fp16 complete:(char)fp20;
- (void)dealloc;
- firstRepProperty:fp12;
- (int)frameCount;
- (int)currentFrame;
- (void)setCurrentFrame:(int)fp12;
- (float)unadjustedFrameDuration;
- (float)frameDuration;
- (int)repetitionCount;
- (void)scheduleFrame;
- (void)drawClippedToValidInRect:(struct _NSRect)fp12 fromRect:(struct _NSRect)fp24;
- (void)nextFrame:fp12;
- (void)beginAnimationInRect:(struct _NSRect)fp12 fromRect:(struct _NSRect)fp24;
- (void)stopAnimation;
- (void)tileInRect:(struct _NSRect)fp12 fromPoint:(struct _NSPoint)fp28;
- (void)resize:(struct _NSSize)fp12;
- (struct _NSSize)size;

@end
